#!/usr/bin/env node
const mkdirp = require('mkdirp');
const fs = require('fs');

let destination;
let config;
mkdirp('executedModules', function(err) {
    if (err) {
        console.error("Cannot create /executedModules directory.");
        console.log("You can do that manual.")
    } else
        fs.writeFile('codis-slave.js', getContentSlaveScriptToFile(), function(err) {
            if (err) {
                console.error("Cannot create codis-slaver.js file.");
                console.log("Copy and paste build-slave-script.js from node_modules as slave-script.js");
            } else
                console.log("Created: slaver script and directory for modules");
                console.log("Destination: " + destination);
        });
        fs.writeFile('sharedInspector.js', fs.readFileSync(__dirname + '/../build/build-sharedInspector.js', 'utf8'), function (err) {
            if (err) {
                console.error('Cannot create sharedInspector.js file.');
                console.log('Copy and paste build-sharedInspector.js from node_modules as sharedInspector.js');
            } else
                console.log('Created: sharedInspector script');
        });
        fs.writeFile('codis.js', getContentCodisScriptToFile(), function (err) {
            if (err) {
                console.error('Cannot create codis.js file.');
                console.log('Copy and paste build-codis.js from node_modules as codis.js');
            } else
                console.log('Created: codis script. Use this file in your html website file.');
        });
});

const getContentSlaveScriptToFile = () => {
    destination = 'ws://localhost:5299';
    if (process.argv[2] === '--destination')
        destination = process.argv[3];
    if (process.argv[4] === '--destination')
        destination = process.argv[5];
    config = {
        destination,
    };
    return 'const config =' + JSON.stringify(config) + ';\n' + fs.readFileSync(__dirname + '/../build/build-slave-script.js', 'utf8');
};

const getContentCodisScriptToFile = () => {
    let onePerSystem = true;
    if (process.argv[2] === '--one-per-system')
        onePerSystem = process.argv[3];
    if (process.argv[4] === '--one-per-system')
        onePerSystem = process.argv[5];
    config = {
        onePerSystem,
    };
    return 'const config =' + JSON.stringify(config) + ';\n' + fs.readFileSync(__dirname + '/../build/build-codis.js', 'utf8');
};
